#ifndef _P2KAPI3_H_
#define _P2KAPI3_H_

#include "DataTypes.h"

typedef enum 
{
	DeviceLost,
	DeviceP2kFound,
} DeviceStatus;

typedef enum 
{
	DeviceLostEx,
	DeviceP2kFoundEx,
	DeviceFlashFoundEx,
} DeviceStatusEx;

extern "C"
{
	typedef void (__stdcall *StatusFunction)(DeviceStatus status);
	typedef void (__stdcall *StatusFunctionEx)(DeviceStatusEx status, const char * sInterfaseName);
	typedef void (__stdcall *ProgressFunction)(FileInfo * pFileInfo, dword dwCurIndex, dword dwTotalCount);

	void   __stdcall SetCOMPort(const char * sPort);

	int    __stdcall P2K_Init(StatusFunction callback);
	int    __stdcall P2K3_Init(StatusFunctionEx callback);
	bool   __stdcall P2K_GetStatus(void);
	dword  __stdcall P2K_GetInterface(char * sInterface, dword dwSize);
	handle __stdcall P2K_GetIFHandle(void);
	void   __stdcall P2K_PowerOff(void);
	void   __stdcall P2K_Restart(void);
	void   __stdcall P2K_Suspend(void);
	int    __stdcall P2K_SuspendEx(dword dwSuspType);
	int    __stdcall P2K_SendCMD(dword dwCommand, byte * pSendBuff, dword dwSendSize, byte * pRecvBuff, dword * pdwRecvSize);
	void   __stdcall P2K_SwitchToFlash(void);

	void   __stdcall Mode_SwitchToP2K(StatusFunction);
	void   __stdcall Mode_SwitchToAT(void);
	void   __stdcall Mode_SwitchToTF(void);

	int    __stdcall Seem_Read(dword dwSeemNo, dword dwRecordNo, dword dwStartOffset, dword dwBytes, byte * pBuffer);
	int    __stdcall Seem_Write(dword dwSeemNo, dword dwRecordNo, dword dwStartOffset, dword dwBytes, const byte * pBuffer);

	int    __stdcall File_Create(const char * sFileName, dword dwAttribute);
	int    __stdcall File_Read(byte * pBuffer, dword dwSize);
	int    __stdcall File_Write(const byte * pBuffer, dword dwSize);
	int    __stdcall File_SetPointer(dword dwOffset, byte bMoveMethod);
	int    __stdcall File_Close();

	int    __stdcall File_Delete(const char * sFileName);
	int    __stdcall File_CreateDir(const char * sDirName, dword dwAttribute);
	int    __stdcall File_DeleteDir(const char * sDirName);
	
	int    __stdcall File_Count();
	int    __stdcall File_CountEx(const char * sDiskNameAndMask);
	int    __stdcall File_VolInfo(byte * pBuffer);
	int    __stdcall File_GetFreeSpace(const char * sDiskName);
	int    __stdcall File_List(FileInfo * pFileList, dword dwCount);
	int    __stdcall File_ListEx(FileInfo * pFileList, dword dwCount, ProgressFunction callback);

	int    __stdcall Flash_Addr(dword dwAddress);
	int    __stdcall Flash_Jump(dword dwAddress);
	int    __stdcall Flash_Bin(const byte * pSendBuff, dword dwSendSize);
	int    __stdcall Flash_Dump(dword dwAddress, const byte * pBuffer);
	int    __stdcall Flash_Read(dword dwAddress, dword dwLength, const byte * pBuffer);

	int    __stdcall Flash_ReadData(byte * pSendBuff, dword * pdwSendSize, dword dwTimeout);
	int    __stdcall Flash_WriteData(const byte * pSendBuff, dword * pdwSendSize, dword dwTimeout);
}

#endif // _P2KAPI3_H_